#include<bits/stdc++.h>
using namespace std;
int n,q,l,r,br;
string ss;
void set1(){
    cout<<r-l<<endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q>>ss;
    for(int i=0;i<n;i++){
        if(ss[i]=='?') br++;
    }
    for(int i=1;i<=q;i++){
        cin>>l>>r;
        if(br==n) set1();
    }
    return 0;
}